# Discord-reporter

![npm](https://img.shields.io/npm/v/maila-discord-reporter) ![GitHub](https://img.shields.io/github/license/maritome/maila-discord-reporter)  



## maila Discord Reporter

A Discord reporter of your test results.  
It uses the allure report generated by maila-allure-plugin (or any other allure reporter) to send a message in a team channel of your choice with the status of the test run.
Everyone gets a fast, short and well-organized feedback of the latest test execution.  
The message sent to discord include:

- Test run status
- How many test cases failed (if there are any)
- The list of the test cases that failed (if there are any)
- How many test cases are broken (if there are any)
- The list of the test cases that are broken (if there are any)
- A link of the allure report generated, which includes all the necessary details

How discord message looks like

![All test cases passed](/assets/screenshots/report-passed.PNG)
![Some test cases failed](/assets/screenshots/report-failed.PNG)
![Some test cases are broken](/assets/screenshots/report-broken.PNG)

## Installation

```
npm install maila-discord-reporter --save-dev
```
## Configuration

Create an incoming webhook for the team channel where you want to get the report. Copy the WEBHOOK URL and add it to your .env file:

```
DISCORD_WEBHOOK_URL = 'yourWebhookUrl'
```

To display in the discord message the name of the application under test and its version when the tests were executed, create a environment.properties file within your allure-results folder. In the file add:

```
Application=Application Under Test
Version=vx.x.x
```

## Usage

```
$ npx maila-discord-reporter
```

```
Usage: index [options]

Options:
  -v, --version          output the version number
  --verbose              show log output
  --report-path [type]   define the path of allure report file (default: "./allure-report/widgets/status-chart.json")
  --testEnv-path [type]  define the path of allure report environment properties file (default: "./allure-report/widgets/environment.json")
  --report-url [type]    provide the link for the Test Report (default: "")
  -h, --help             display help for command
```

If the allure report is uploaded somewhere, provide the link using the option `--report-url`. A button 'Open Test Report' will be part of discord message. Onclick it, the allure test report will be opened.

Project forked from [maila-msteams-reporter](https://github.com/maritome/maila-msteams-reporter) by Maria Tome
